/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#ifndef _TCentralComponent_h_
#define _TCentralComponent_h_
//---------------------------------------------------------------------
#include "../JuceLibraryCode/JuceHeader.h"
//---------------------------------------------------------------------
// Класс компонента содержимого.
// Наследует класс слушателя кнопок и др.
class TCentralComponent  : public Component,
                           public ComboBoxListener,
                           public ButtonListener,
                           public KeyListener // слушатель клавиш
{
public:
    TCentralComponent();
    ~TCentralComponent();

    void paint(Graphics&);
    void resized();
    // Функция, отслеживающая изменения выпадающего списка
    void comboBoxChanged(ComboBox*);
    // Функция, отслеживающая щелчки по кнопке
    void buttonClicked(Button*);
    // Функция, отслеживающая нажатие клавиш в области 
    // полей ввода
    bool keyPressed(const KeyPress&, Component*);

private:
    TextEditor* pTextEditor;
    TextEditor* pAppendTextEdit;
    ComboBox* pFontSelectionBox;
    TextButton* pClearButton;
    TextButton* pAppendTextButton;
    TextButton* pSetTextButton;
    Label* pSeparator;
    Label* pLabel;
    GroupComponent* pLabelGroup;
    ToggleButton* pReadOnlyButton;
    ToggleButton* pEditByOneClickButton;
    ToggleButton* pEditByDoubleClickButton;
    Label* pSeparator1;
    Label* pPasswordLabel;
    TextEditor* pPasswordEdit;
    TextButton* pSubmitButton;

    // Строка для хранения пароля
    String sPassword;

    // Функция ввода пароля
    void SubmitPassword();

    // Предотвращает создание копии конструктора и оператора =
    TCentralComponent(const TCentralComponent&);
    const TCentralComponent& operator= (const TCentralComponent&);
};
//---------------------------------------------------------------------
#endif
